package com.safeway.epe.offersdataproducer.mapper;

import com.safeway.epe.offersdataproducer.bomodel.*;
import com.safeway.epe.offersdataproducer.dtomodel.*;
import org.mapstruct.CollectionMappingStrategy;
import org.mapstruct.Mapper;
import org.mapstruct.Mapping;


@Mapper(collectionMappingStrategy = CollectionMappingStrategy.TARGET_IMMUTABLE, componentModel = "spring")
public interface BoToDtoMapper {
    @Mapping(target="offersDTO",source="offersBO")
    OffersDataDTO map(OffersDataBO offersDataBO);

    @Mapping(target="rulesDTO",source="rulesBO")
    @Mapping(target="infoDTO",source="infoBO")
    OffersDTO map(OffersBO offersBO);

    @Mapping(target="idDTO",source="idBO")
    @Mapping(target = "terminalsDTO",source="terminalsBO")
    InfoDTO map(InfoBO infoBO);

    IdDTO map(IdBO idBO);

    @Mapping(target="benefitDTO",source="benefitBO")
    RulesDTO map(RulesBO rulesBO);

    @Mapping(target = "pointsDTO",source="pointsBO")
    @Mapping(target = "discountDTO",source="discountBO")
    BenefitDTO map(BenefitBO BenefitBO);

    @Mapping(target = "discountTierDTO",source="discountTierBO")
    DiscountDTO map(DiscountBO DiscountBO);

    DiscountTierDTO map(DiscountTierBO discountTierBO);

    PointsDTO map(PointsBO pointsBO);
}

