package com.safeway.epe.offersdataproducer.producer;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.safeway.epe.offersdataproducer.appconfiguration.AppConfigs;
import com.safeway.epe.offersdataproducer.dtomodel.OffersDataDTO;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.kafka.support.SendResult;
import org.springframework.stereotype.Component;
import org.springframework.util.concurrent.ListenableFuture;

@Component
public class OffersDataProducer {
    private static final Logger logger = LoggerFactory.getLogger(OffersDataProducer.class);
    @Autowired
    private KafkaTemplate<String, String> kafkaTemplate;
    @Autowired
    private ObjectMapper objectMapper;
    public ListenableFuture<SendResult<String, String>> sendMessage(OffersDataDTO offersDataDTO) throws JsonProcessingException {
        logger.info(String.format("$$ -> Producing message --> %s", offersDataDTO));
        String offersDataBOResp = objectMapper.writeValueAsString(offersDataDTO);
        ListenableFuture<SendResult<String, String>> message=  kafkaTemplate.send(AppConfigs.TOPIC_NAME, offersDataBOResp);
        return message;
    }
}
