package com.safeway.epe.offersdataproducer.service.impl;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.safeway.epe.offersdataproducer.bomodel.OffersDataBO;
import com.safeway.epe.offersdataproducer.domodel.OffersDataDO;
import com.safeway.epe.offersdataproducer.dtomodel.OffersDataDTO;
import com.safeway.epe.offersdataproducer.producer.OffersDataProducer;
import com.safeway.epe.offersdataproducer.service.OffersDataProducerService;
import com.safeway.epe.offersdataproducer.transformer.OffersDataBoToDTO;
import com.safeway.epe.offersdataproducer.transformer.OffersDataDoToBo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.kafka.support.SendResult;
import org.springframework.stereotype.Service;
import org.springframework.util.concurrent.ListenableFuture;

@Service
public class OffersDataProducerServiceImpl implements OffersDataProducerService {
    @Autowired
    private OffersDataBoToDTO offersDataBoToDTO;
    @Autowired
    private OffersDataDoToBo offersDataDoToBo;
    @Autowired
    private OffersDataProducer offersDataProducer;
    @Override
    public ListenableFuture<SendResult<String, String>> publishOfferEvent(OffersDataDO offersDataDO) throws JsonProcessingException {
        OffersDataBO offersDataBO = offersDataDoToBo.transerToBo(offersDataDO);
        OffersDataDTO offersDataDTO = offersDataBoToDTO.transferToDTO(offersDataBO);
        ListenableFuture<SendResult<String, String>> eventStatus = offersDataProducer.sendMessage(offersDataDTO);
        return eventStatus;
    }
}
